#ifndef __LIFEGAMEAPP_HPP
#define __LIFEGAMEAPP_HPP

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEShell.h"

#include "LifeGameApp.bid"

enum STATE_ENUM {
    STATE_TITLE,
    STATE_GAMESTART,
    STATE_EDIT,
    STATE_SAVE,
    STATE_LOAD,
    STATE_CHANGESIZE
};

class WindowManager;
class SoftKeyWindow;
class LifeGame;

typedef struct _LifeGameApp {
	AEEApplet      a ;
    AEEDeviceInfo  DeviceInfo;
    IDisplay      *pIDisplay;
    IShell        *pIShell;
    WindowManager  *WindowManager;
} LifeGameApp;


/*abstract*/ class Window {
protected:
    WindowManager* wm;
public:
    Window(WindowManager* wm_) { wm = wm_; }
    virtual ~Window() {}
    virtual void paint() = 0;
    virtual void keyPress(uint16 key) = 0;
};


class WindowManager {
public:
    IDisplay* display;
    IShell* shell;
    LifeGame* lifeGame;
    Window* frontWindow;
public:
    SoftKeyWindow* skwindow;
public:
    WindowManager (LifeGameApp* app);
    ~WindowManager();
    void changeState(STATE_ENUM state);
    void setCurrent(Window* window);
    void keyPress(uint16 key) { frontWindow->keyPress(key); }
    void update(IDisplay* disp);
};

#endif //__LIFEGAMEAPP_HPP
