package com.s_cradle.lifeapp;

import com.nttdocomo.ui.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: Sophia Cradle, Inc.</p>
 *
 * @author YOSHIMURA Masaru
 * @version $Id$
 */

public class SavePanel extends MemoryPanel implements ComponentListener{
  private ListBox list;
  private TextBox textBox;
  private Button saveButton;
  private Button removeButton;
  private Button renameButton;

  public SavePanel(LifeGameApplication appli, LifeGame game) {
    super(appli, game);

    load();

    list = new ListBox(ListBox.SINGLE_SELECT,len+1);
    for(int i=0;i<len;i++){
      list.append(data[i].getName());
    }
    list.append("new place");
    list.select(len);

    add(new Label("where?"));
    add(list);
    add(new Label("New name?"));
    textBox = new TextBox("temp",20,1,TextBox.DISPLAY_ANY);
    add(textBox);
    saveButton = new Button("save");
    add(saveButton);
    removeButton = new Button("remove");
    add(removeButton);
    renameButton = new Button("rename");
    add(renameButton);

    setComponentListener(this);
  }

  public void componentAction(Component source, int type, int param) {
    if(type == ComponentListener.BUTTON_PRESSED){
      if(source == saveButton){
        if (list.getSelectedIndex() == len) {
          data[len] = new LifeGameData( textBox.getText(), game.getMatrix());
          len++;
        }
      } else if(source == removeButton){
        for(int i=list.getSelectedIndex();i<len-1;i++){
          data[i] = data[i+1];
        }
        len--;
      } else if(source == renameButton){
        if(list.getSelectedIndex() != len){
          data[list.getSelectedIndex()].setName(textBox.getText());
        }
      }

      save();

      appli.changeState(LifeGameApplication.STATE_TITLE);
    }
  }
}
